#!/usr/local/bin/ruby

=begin
Copyright (c) 1999, Yasuhiro ABE <m5031201@u-aizu.ac.jp>
Copyright (c) 2000, Yasuhiro ABE <yasu@dengaku.org>


apache$B$N(Breferer_log$B%U%!%$%k$+$i!";2>H@h$N%j%9%H$r:n@.$7$^$9!#(B

$BF~NO!'(Bapache$B$N(Breferer_log ($BMM<0!'(BLogFormat "%{Referer}i -> %U")
$B=PNO!'(BHTML$B7A<0(B

$B$3$s$J46$8$+$J!#$"$^$j$K$b9T?t$,B?$1$l$P>e0L(B30$B$H$+!"2<0L(B20$B$H$+(B
$B=PNO$G$-$k$h$&$KJQ99$7$^$7$g$&!#(B

[5/30] $B7k6I(B '--min num' $B%*%W%7%g%s$K$h$C$F(Bnum$BHVL\0J>e$N%"%/%;%92s?t$N(BURL$B$r(B
$BI=<($9$k$h$&$KJQ99$7$?!#(B

@db$B%*%V%8%'%/%H$O(B key = '$B;2>H85(Burl', value = '$B%"%/%;%92s?t(B' $B$K$9$k(B

[6/18 2000] $B>/$J$/$H$b$A$c$s$H?t$r$A$c$s$H?t$($i$l$k$h$&$KJQ99$7$?!#(B
=end

if require "gdbm"
  $DBTYPE = "gdbm"
elsif require "dbm"
  $DBTYPE = "dbm"
else
  print  "cannot choose any db system\n"
  exit
end

class Refer
  @db # database object: methods can get information from this object
  @dbtmp_name

  def initialize (file)
    dbtmp_name = "dbm.aaa"
    
    if $DBTYPE == "dbm"
      while FileTest.exist?(File::Separator+"tmp"+File::Separator+dbtmp_name+".dir")
	dbtmp_name.succ!
      end
    elsif $DBTYPE == "gdbm"
      while FileTest.exist?(File::Separator+"tmp"+File::Separator+dbtmp_name)
	dbtmp_name.succ!
      end
    end
    @dbtmp_name = File::Separator+"tmp"+File::Separator+dbtmp_name
    
    
    if $DBTYPE == "dbm"
      @db = DBM.open(@dbtmp_name)
    elsif $DBTYPE == "gdbm"
      @db = GDBM.open(@dbtmp_name)
    end
    begin
      f = open(file)
      f.each_line {|line|
	url,other = line.split("->",2)
	if @db[url] 
	  @db[url] = @db[url].to_i + 1
	else
	  @db[url] = 1
      end
      }
    rescue
      print "Error: input file is not correct!\n"
      exit
    ensure
      f.close if f
    end
  end
  
  def cleaner
    dbtmp_name = @dbtmp_name
    if $DBTYPE == "dbm"
      if FileTest.exist?(dbtmp_name+".dir") and FileTest.exist?(dbtmp_name+".pag")
	File.unlink(dbtmp_name+".dir")
	File.unlink(dbtmp_name+".pag")
      end
    elsif $DBTYPE == "gdbm"
      File.unlink(dbtmp_name) if FileTest.exist?(dbtmp_name)
    end
  end

  def make_list(min_count = 10, mode = 0)
    # make the array, and the value (url) must be also array
    @array = Array.new(100)
    @db.each {|url,count|
      if mode == 0
	next if count.to_i < min_count
      else
	next if count.to_i > min_count
      end
      count = Integer(count)
      if @array[count]
	@array[count] += url
      else
	@array[count] = [url]
      end
    }
  end

  def show_ordered_list (min_count = 10)
    self.make_list(min_count)

    # make the list from the sorted array
    @array.each { |urls|
      
      next if urls == nil
      index = @array.index(urls)
      
      urls.each {|url|
	if index and url
	  print "[" + index.to_s + "] "
	  print "<A href=\"#{url}\">#{url}</A>\n<BR>"
	end
      }
    }
  end

  def show_r_ordered_list (min_count = 10)
    self.make_list(min_count, 1)

    # make the list from the sorted array
    @array.reverse_each { |urls|
      
      next if urls == nil
      index = @array.index(urls)
      urls.each {|url|
	if index and url
	  print "[" + index.to_s + "] "
	  print "<A href=\"#{url}\">#{url}</A>\n<BR>"
	end
      }
    }
  end
  
  def show_header()
    print <<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN"
    "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML><HEAD>
<TITLE>Welcome to my Homepage</TITLE>
<LINK rel="STYLESHEET" href="http://www.u-aizu.ac.jp/%7Em5031201/style/default.css" type="text/css">
<STYLE type="text/css">
</STYLE>
</HEAD><BODY>
<H1>Referer Log Analyzer</H1>
<P class=greeting">Created at [ #{%x{date}} ]
<HR>
EOF
  end

  def show_footer()
    print <<EOF
<HR>
<P>$B$3$N=PNO$O0$ItBYM5$N:n@.$7$?(B#{$0}$B$K$h$j:n@.$5$l$^$7$?!#(B
<address><a href="http://www.u-aizu.ac.jp/%7Em5031201/">Yasuhiro Abe &lt;m5031201@u-aizul.ac.jp&gt;</a></address>
</BODY></HTML>
EOF
  end
end

####################
# $B%*%W%7%g%s$N=hM}(B
####################
require "parsearg.rb"
def usage()
  printf "Usage:\n"
  printf "%s [--min number] [-r|--reverse] [-v|--version] [-t|--title]logfile\n", $0
  printf "\t--min number:\tdefine the minimum number for output\n"
  printf "\t-r|--reverse:\tordered from maximum size\n"
  printf "\t-v|--version:\tshow version infromation\n"
  printf "\t-t|--title:\tadd title header with documents(not installed)\n"
end
$USAGE = 'usage'
parseArgs(1, nil, "r","v","t", "min:","title","reverse","version")
if $OPT_v or $OPT_version
  print "Version 2.00\n"
  exit
end

# min_num$B$NDj5A(B
if $OPT_min
  min_num = $OPT_min.to_i
else
  min_num = 3
end

###########
# $B=hM}K\BN(B
###########
if FileTest.exist?(ARGV[0])
  refer = Refer.new(ARGV[0])  
else
  print "Error: cannot read #{ARGV[0]}!"
  exit
end


refer.show_header()
if $OPT_r or $OPT_reverse 
  refer.show_r_ordered_list(min_num)
else
  refer.show_ordered_list(min_num)
end
refer.show_footer()
refer.cleaner()
